//---------------------------------------------------------------------------
#ifndef UnRarH
#define UnRarH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>

#if __BORLANDC__==0x520
#define __UnrarBCB1__
#define UNRAR_package
#define UNRAR_dcr
#else
#define __UnrarBCB3__
#define UNRAR_smartinit
#define UNRAR_package PACKAGE
#define UNRAR_dcr USERES("UnRar.dcr");
#endif

enum TResult { resNone, resOk, resNoMemory, resBadData, resBadArchive, resOpenError, resEndOfFile, resCloseError, resCreateError, resReadError, resWriteError, resUnknownFormat, resDllError };
enum TCommentState { csNone, csOk, csNoMemory, csBadData, csUnknownFormat };
enum TFileFlag { ffPrevVolume, ffNextVolume, ffPassword, ffComment, ffSolid, ffDirectory };
typedef Set <TFileFlag, ffPrevVolume, ffDirectory> TFileFlags;
enum THostOS { hosMsDos, hosOS2, hosWin32, hosUnix };
enum TRarOperation { opSkip, opTest, opExtract };

class EUnRarError : public Exception
{
private:
   TResult fResult;
protected:
   static String __fastcall GetErrString(TResult res);
public:
   __fastcall EUnRarError(TResult res) : Exception(GetErrString(res)), fResult(res) { }

   __property TResult Result = { read=fResult };
};

class UNRAR_package TUnRar : public TComponent
{
private:
   HINSTANCE hDll;
   HANDLE fHandle;
   TResult fResult;
   bool fIsOpen;
   bool fEof;
   bool fExtract;
   bool fActive;
   bool fExceptionOnError;

   AnsiString fArchiveName;
   AnsiString fArchiveComment;
   TCommentState fArchiveCommentState;
   AnsiString fFileName;
   AnsiString fComment;
   TCommentState fCommentState;
   TFileFlags fFlags;
   int fDictionarySize;
   unsigned fPackedSize;
   unsigned fUnpackedSize;
   THostOS fHostOS;
   unsigned fCRC;
   unsigned fFileTime;
   int fRarVersion;
   int fMethod;
   unsigned fAttr;
   AnsiString fPassword;
   AnsiString fDestPath;
protected:
   bool __fastcall ReadHeader();
   void __fastcall SetPassword(AnsiString s);
   void __fastcall SetActive(bool active);
public:
   static AnsiString ChangeDiskTitle;
   static Forms::TModalResult ChangeDiskModalResult;

   __fastcall TUnRar(Classes::TComponent* AOwner);
   __fastcall ~TUnRar();
   bool __fastcall Open(); //AnsiString filename, bool extract=false);
   bool __fastcall Close();
   bool __fastcall Process(TRarOperation op=opSkip, AnsiString DestName="");

   __property bool Active = { read=fActive, write=SetActive };
   __property TResult Result = { read=fResult };
   __property bool Eof = { read=fEof };
   __property AnsiString ArchiveComment = { read=fArchiveComment };
   __property TCommentState ArchiveCommentState = { read=fArchiveCommentState };
   __property AnsiString FileName = { read=fFileName };
   __property AnsiString Comment = { read=fComment };
   __property TCommentState CommentState = { read=fCommentState };
   __property TFileFlags FileFlags = { read=fFlags };
   __property int DictionarySize = { read=fDictionarySize };
   __property unsigned PackedSize = { read=fPackedSize };
   __property unsigned UnpackedSize = { read=fUnpackedSize };
   __property THostOS HostOS = { read=fHostOS };
   __property unsigned CRC = { read=fCRC };
   __property unsigned FileTime = { read=fFileTime };
   __property int RarVersion = { read=fRarVersion };
   __property unsigned Attr = { read=fAttr };
__published:
   __property AnsiString ArchiveName = { read=fArchiveName, write=fArchiveName };
   __property bool Extract = { read=fExtract, write=fExtract, default=false };
   __property AnsiString Password = { read=fPassword, write=SetPassword };
   __property AnsiString DestPath = { read=fDestPath, write=fDestPath };
   __property bool ExceptionOnError = { read=fExceptionOnError, write=fExceptionOnError, default=true };
};

#endif
