#ifndef _UnRar_H_
#define _UnRar_H_

#define ERAR_END_ARCHIVE     10
#define ERAR_NO_MEMORY       11
#define ERAR_BAD_DATA        12
#define ERAR_BAD_ARCHIVE     13
#define ERAR_UNKNOWN_FORMAT  14
#define ERAR_EOPEN           15
#define ERAR_ECREATE         16
#define ERAR_ECLOSE          17
#define ERAR_EREAD           18
#define ERAR_EWRITE          19
#define ERAR_SMALL_BUF       20

#define RAR_OM_LIST           0
#define RAR_OM_EXTRACT        1

#define RAR_SKIP              0
#define RAR_TEST              1
#define RAR_EXTRACT           2

#define RAR_VOL_ASK           0
#define RAR_VOL_NOTIFY        1

struct RARHeaderData
{
  char ArcName[260];
  char FileName[260];
  UINT Flags;
  UINT PackSize;
  UINT UnpSize;
  UINT HostOS;
  UINT FileCRC;
  UINT FileTime;
  UINT UnpVer;
  UINT Method;
  UINT FileAttr;
  char *CmtBuf;
  UINT CmtBufSize;
  UINT CmtSize;
  UINT CmtState;
};


struct RAROpenArchiveData
{
  char *ArcName;
  UINT OpenMode;
  UINT OpenResult;
  char *CmtBuf;
  UINT CmtBufSize;
  UINT CmtSize;
  UINT CmtState;
};

typedef HANDLE __stdcall (*PROCUnRarOpen)(RAROpenArchiveData*);
typedef int __stdcall (*PROCUnRarClose)(HANDLE);
typedef int __stdcall (*PROCUnRarHeader)(HANDLE, RARHeaderData*);
typedef int __stdcall (*PROCUnRarProcess)(HANDLE, int, char*, char*);
typedef void __stdcall (*PROCUnRarSetChangeVolProc)(HANDLE, int (*)(char*, int));
typedef void __stdcall (*PROCUnRarSetPassword)(HANDLE, char*);

/*
extern "C" HANDLE __stdcall RAROpenArchive(struct RAROpenArchiveData *ArchiveData);
extern "C" int __stdcall RARCloseArchive(HANDLE hArcData);
extern "C" int __stdcall RARReadHeader(HANDLE hArcData,struct RARHeaderData *HeaderData);
extern "C" int __stdcall RARProcessFile(HANDLE hArcData,int Operation,char *DestPath,char *DestName);
extern "C" void __stdcall RARSetChangeVolProc(HANDLE hArcData,int (*ChangeVolProc)(char *ArcName,int Mode));
extern "C" void __stdcall RARSetProcessDataProc(HANDLE hArcData,int (*ProcessDataProc)(unsigned char *Addr,int Size));
extern "C" void __stdcall RARSetPassword(HANDLE hArcData,char *Password);
*/

#endif /* _UnRar_H_ */
